#!/bin/bash
echo '

Note: You can quit at any time by pressing Ctrl-C (twice).

This script will help you create the nisperod.cf file for the
nispero daemon.
'
HOST=`hostname`
echo -n "For which host will we create the config file? [$HOST] "
read ANS
if ! [ x"$ANS" == x ] ; then HOST=$ANS ; fi

PORT=/dev/ttyS0
echo -n "On which device will be attached the nispero device [/dev/ttyS0] "
read ANS
if ! [ x"$ANS" == x ] ; then PORT=$ANS ; fi

SOCKET="/tmp/stonith.socket"
echo -e "\nWhere should Heartbeat Nispero STONITH plugin look for the" 
echo -n "socket? (I recommend using the default) [$SOCKET] "
read ANS 
if ! [ x"$ANS" == x ] ; then SOCKET=$ANS ; fi

PASSWORD="STONITH"
echo -e '\nNow we should create the users that are allowed to talk to the
daemon. Let us start by creating a heartbeat user:'
echo -n "Type the password for heartbeat: [STONITH] "
read ANS
if ! [ x"$ANS" == x ] ; then PASSWORD=$ANS ; fi

echo -e "\nIt is wise to create a root user too, so you can have full access to the daemon. \
I will create one for you:"
echo -n 'password for root: [blank line to skip this step] '
ROOTPASSWORD=""
read ANSWER
if [ x"$ANSWER" == x ] ; then
	echo "Ok, not creating root account..."
fi
ROOTPASSWORD=$ANSWER

RESET=10
echo -n 'time in seconds to sleep between OFF -> ON, 0 to leave OFF: [10] '
read ANSWER
if ! [ x"$ANSWER" == x ] ; then RESET=$ANSWER ; fi


echo -e '\nYour configuration looks like this:\n'
echo '---'
echo -e "# Configuration file created by $0"
echo -e "# configuration for node: $HOST"
echo "port $PORT"
echo "socket $SOCKET"
echo -e "auth\t STONITH\t $PASSWORD\t simple"
if ! [ x"$ROOTPASSWORD" == x ] ; then
	echo -e "auth\t root\t $ROOTPASSWORD\t extended"
fi
echo '---'
echo -e '# The /etc/ha.d/ha.cf file, "stonith_host *" line should look like this:\n'
echo 'stonith_host * m_nispero '$SOCKET $HOST $PASSWORD $RESET
echo '---'

FILE="/etc/nisperod/nisperod.cf"
echo -n "Where shall I save these settings to? [$FILE] "
read ANS
if ! [ x"$ANS" == x ] ; then FILE=$ANS ; fi

touch $FILE >& /dev/null
if [ $? -ne 0 ] ; then
	FILE="/tmp/nisperod.cf.auto"
	echo -e "\n*** Error while accessing $FILE, saving config to $FILE\n"
fi
echo -e "# Configuration file created by $0" > $FILE
echo -e "# configuration for node: $HOST" >> $FILE
echo "port $PORT" >> $FILE
echo "socket $SOCKET" >> $FILE
echo -e "auth\t STONITH\t $PASSWORD\t simple" >> $FILE
if ! [ x"$ROOTPASSWORD" == x ] ; then >> $FILE
	echo -e "auth\t root\t $ROOTPASSWORD\t extended" >> $FILE
fi

echo "Configuration saved to: $FILE."

