/*
 * Copyright (C) 2004 Andres Sajo
 *
 * This file is part of the nisperod package.
 *
 * nisperod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 */
 
 
#include "nisperod.h"
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

volatile int term = FALSE;

void nispero_term(int sig){
	struct child_pid_t * tmp;
	syslog(LOG_INFO, "cought signal SIGTERM, exiting.");
	       
	tmp = chld_st;
	while (tmp != NULL){
#ifdef DEBUG	
		printf("sending to %i\n", tmp->pid);
#endif
		if (kill(tmp->pid, SIGUSR1) != 0){
			syslog(LOG_ERR, "error broadcasting signal to %i: %s", tmp->pid, sys_errlist[errno]);
		}
		tmp = tmp->next;
		/* give some time for the parent to wait for this child */
		sleep(2);
		
	}
	term = TRUE;
	return;
}

void nispero_wait(int sig){
	pid_t pid;
	/* syslog(LOG_INFO, "cought signal SIGCHLD, waiting for child to exit..."); */
	pid = waitpid(-1, NULL, 0);
	if (pid > 0){
		syslog(LOG_INFO, "a child (%i) exited and was waited gracefully", pid);
		if (rem_pool(pid) != 0){
			syslog(LOG_ERR, "pid %i, was not found in stack!", pid);
		}
		/* chldcount--; */
	} else {
		syslog(LOG_ERR, "a child did NOT exit gracefully: %i, %s", errno, sys_errlist[errno]);
	}
	return;
}


/* child signal handler */
void unixds_term(int sig){
	syslog(LOG_INFO, "child: cought SIGUSR1, exiting.");
	close_accept_connect();
}
